//---------------------------------------------------------------------------
//
// Routines d'affichage
//
//---------------------------------------------------------------------------

#include "Osc.h"
#include "math.h"

//---------------------------------------------------------------------------
// Thread Affich
//---------------------------------------------------------------------------

DWORD __stdcall TFenetre::Thread_Affich(LPVOID lpParam) {


HANDLE hEvents[3];
DWORD event;
bool fini = false;

while(!fini) {
        hEvents[0]=Fenetre->Event[STOP_AFF];    //fin du prgm
        hEvents[1]=Fenetre->Event[AFFICH_OK];   //ordre d'afficher

        event = WaitForMultipleObjects(2,hEvents,FALSE,INFINITE);
        switch(event) {
        case WAIT_OBJECT_0:     //fin du prgm
                fini = true;
                ReleaseMutex(Fenetre->mutex_aff);
                break;

        case WAIT_OBJECT_0+1:     //aff_ok
                hEvents[0]=Fenetre->mutex_aff;    //fin du prgm
                hEvents[1]=Fenetre->Event[AFFICH_OK];   //ordre d'afficher
                WaitForMultipleObjects(2,hEvents,TRUE,INFINITE);
                Fenetre->Dessine();
                ReleaseMutex(Fenetre->mutex_aff);
                break;
        }// fin switch
} //fin boucle infinie

SetEvent(Fenetre->Event[TH_AFF_FINI]);
//fin du thread
return 0;

}


void __fastcall TFenetre::Dessine()
{
        CharToDouble(buffer_a,val);
        InitializeCriticalSection(&GlobalCriticalSection);
        EnterCriticalSection(&GlobalCriticalSection);
        dc = GetDC(Fenetre->WindowHandle);
        if(Bool_FFT == false)
        {Edit_periode->Text = FloatToStrF((Periode(val, N, 1))*2*ModeTmp[tmp_div].div,ffExponent,2,2) +" s";
        MinMax(max, min);
        EditMin->Text = FloatToStrF((min-128)*ModeV[v_div].div,ffFixed,4,2) + " V";
        EditMax->Text = FloatToStrF((max-128)*ModeV[v_div].div,ffFixed,4,2) + " V";
        DessineGraph(Trigger(ScrollBar_Sensible->Position));}
        else DessineFFT();
        AfficheCurseur();
        ReleaseDC(Fenetre->Handle,dc);
        LeaveCriticalSection(&GlobalCriticalSection);
}



void __fastcall TFenetre::Im_CurseurClick(TObject *Sender)
{
  double delta_temp;

  if(Bool_Curseur1 == true) {
  X1 = Xtemp;
  Y1 = Ytemp;
  Bool_Curseur1 = false;
  Button_Curseur1->Caption = "Curseur 1";
  click1_save = true;    //si des valeurs ont t sauves, alors on affiche

  }
  else if(Bool_Curseur2 == true){
  X2 = Xtemp;
  Y2 = Ytemp;
  Bool_Curseur2 = false;
  Button_Curseur2->Caption = "Curseur 2";
  click2_save = true;
  }

  if(click1_save==true && click2_save==true) {
    if(!Bool_FFT) {delta_temp= (X2-X1)*2*ModeTmp[tmp_div].div;
        DeltaX->Text = FloatToStrF(delta_temp,ffExponent,2,2)+" s";
        delta_temp = (abs(Y2-Y1))*ModeV[v_div].div;
        DeltaY->Text = FloatToStrF(delta_temp,ffFixed,4,2)+ " V";}
    else {delta_temp= (X2-X1)/2.0 * (1.0/(N*ModeTmp[tmp_div].div));
        DeltaX->Text = FloatToStrF(delta_temp,ffExponent,2,2) + " Hz";
        DeltaY->Text = "";}

  }
}
//---------------------------------------------------------------------------

void __fastcall TFenetre::Im_CurseurMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
double delta_temp;

  Im_Curseur->Cursor = crCross;
  if(!Bool_FFT) Edit1->Text = X*2*ModeTmp[tmp_div].div;
  else Edit1->Text = double(X/2.0 * (1.0/(1024.0*ModeTmp[tmp_div].div)));

  Edit2->Text = (128-Y)*ModeV[v_div].div;
  Xtemp = X;
  Ytemp = Y;

  if(click1_save==true && Bool_Curseur2==true) {
  if(!Bool_FFT) {delta_temp = (Xtemp-X1)*2*ModeTmp[tmp_div].div;
  DeltaX->Text= FloatToStrF(delta_temp,ffExponent,2,2)+" s";
  delta_temp = (abs(Ytemp-Y1))*ModeV[v_div].div;
  DeltaY->Text = FloatToStrF(delta_temp,ffFixed,4,2)+ " V";}
  else { delta_temp = (Xtemp-X1)/2.0 * (1.0/(N*ModeTmp[tmp_div].div));
  DeltaX->Text = FloatToStrF(delta_temp,ffExponent,2,2) + " Hz";
  DeltaY->Text = "";}

  }
  else if(click2_save==true && Bool_Curseur1==true)
  {
  if(!Bool_FFT) { delta_temp = (X2-Xtemp)*2*ModeTmp[tmp_div].div;
  DeltaX->Text = FloatToStrF(delta_temp,ffExponent,2,2)+" s";;
  delta_temp = (abs(Y2-Ytemp))*ModeV[v_div].div;
  DeltaY->Text = FloatToStrF(delta_temp,ffFixed,4,2)+ " V";}
  else { delta_temp = (X2-Xtemp)/2.0 * (1.0/(N*ModeTmp[tmp_div].div));
  DeltaX->Text = FloatToStrF(delta_temp,ffExponent,2,2) + " Hz";
  DeltaY->Text = "";}
  }
  SetEvent(Event[AFFICH_OK]);
}

void __fastcall TFenetre::DessineGraph(int debut)
{
        RECT surf;
        surf.left=X0;
        surf.top=Y0;
        surf.right=X0+LARGEUR;
        surf.bottom=Y0+HAUTEUR+1;
        FillRect(dc,&surf,(HBRUSH)(0));

        //dessine en gris

        SelectObject(dc,crayon_gris);

        //ligne horizontales
        for(int i=HAUTEUR/8+Y0;i<HAUTEUR+Y0;i+=HAUTEUR/8) {
        MoveToEx(dc,X0,i,NULL);
        LineTo(dc,X0+LARGEUR,i);
        }

        //lignes verticales
        for(int i=X0+LARGEUR/10;i<LARGEUR+X0;i+=LARGEUR/10) {
        MoveToEx(dc,i,Y0,NULL);
        LineTo(dc,i,Y0+HAUTEUR);
        }

        //crayon bleu zoli :)

        SelectObject(dc,crayon_bleu);

        //dessine en commencant par debut
        MoveToEx(dc,X0,(Y0+HAUTEUR)-val[debut],NULL);
        for(int i=1;i<=LARGEUR-1;i++) // Affichage des 511 autres pixels
        {
        LineTo(dc,i+X0,(Y0+HAUTEUR)-val[i+debut]);
        }

        // Dessine la position du Trigger

        SelectObject(dc,crayon_trig);
        MoveToEx(dc,X0,Y0+ScrollBar_Trigger->Position,NULL);
        LineTo(dc,X0+LARGEUR,Y0+ScrollBar_Trigger->Position);

}

void __fastcall TFenetre::DessineFFT()
{
       //Conversion de tableaux

       fft_tablo = new double[2*N];

       FFTiter(val ,512 , fft_tablo);

        RECT surf;
        surf.left=X0;
        surf.top=Y0;
        surf.right=X0+LARGEUR;
        surf.bottom=Y0+HAUTEUR;
        FillRect(dc,&surf,(HBRUSH)(0));

        //dessine en gris
        SelectObject(dc,crayon_gris);

        //ligne horizontales
        for(int i=HAUTEUR/8+Y0;i<HAUTEUR+Y0;i+=HAUTEUR/8) {
        MoveToEx(dc,X0,i,NULL);
        LineTo(dc,X0+LARGEUR,i);
        }

        //lignes verticales
        for(int i=X0;i<LARGEUR+X0;i+=LARGEUR/10) {
        MoveToEx(dc,i,Y0,NULL);
        LineTo(dc,i,Y0+HAUTEUR);
        }

        //crayon bleu zoli :)
        SelectObject(dc,crayon_bleu);

        //dessine la FFT
	for(int i=0;i<LARGEUR;i++)
		{
	        MoveToEx(dc,X0+i,(Y0+HAUTEUR)-1,NULL);
                if(abs((double)6.0*fft_tablo[i])<=255) fft_tablo[i] = abs((double)6.0*fft_tablo[i]); else fft_tablo[i] = 255;
        	LineTo(dc,X0+i,(Y0+HAUTEUR-1)-fft_tablo[i]);
		}
        delete fft_tablo;
}

void TFenetre::AfficheCurseur()
{

  if(Bool_Curseur1 == true)
  {
  SelectObject(dc,crayon_cur1);

  MoveToEx(dc,X0,Ytemp+Y0,NULL);
  LineTo(dc,X0+LARGEUR,Ytemp+Y0);

  MoveToEx(dc,Xtemp+X0,Y0,NULL);
  LineTo(dc,Xtemp+X0,Y0+HAUTEUR);
  }
  if(Bool_Curseur2 == true) {
  SelectObject(dc,crayon_cur2);

  MoveToEx(dc,X0,Ytemp+Y0,NULL);
  LineTo(dc,X0+LARGEUR,Ytemp+Y0);

  MoveToEx(dc,Xtemp+X0,Y0,NULL);
  LineTo(dc,Xtemp+X0,Y0+HAUTEUR);
  }

  if(click1_save == true && Bool_Curseur1 == false) { // Si le curseur 1 a deja t plac
  SelectObject(dc,crayon_cur1);

  MoveToEx(dc,X0,Y1+Y0,NULL);
  LineTo(dc,X0+LARGEUR,Y1+Y0);

  MoveToEx(dc,X1+X0,Y0,NULL);
  LineTo(dc,X1+X0,Y0+HAUTEUR);
  }

  if(click2_save == true && Bool_Curseur2 == false) { // Si le curseur 2 a deja t plac
  SelectObject(dc,crayon_cur2);

  MoveToEx(dc,X0,Y2+Y0,NULL);
  LineTo(dc,X0+LARGEUR,Y2+Y0);

  MoveToEx(dc,X2+X0,Y0,NULL);
  LineTo(dc,X2+X0,Y0+HAUTEUR);
  }

}


