//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Osc.h"
#include "Bonjour.h"

#include "math.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFenetre *Fenetre;

//---------------------------------------------------------------------------
__fastcall TFenetre::TFenetre(TComponent* Owner)
        : TForm(Owner)
{
//Evts pr synchro les threads
Event = new HANDLE[NB_EVENTS];

// Tableau de valeurs
val = new double[N];
//buffer lecture & affichage
buffer_l = new unsigned char[N+1];
buffer_a = new unsigned char[N];
for(int i=0; i<N; i++) buffer_a[i]=127;

Im_Curseur->Left = X0;
Im_Curseur->Top = Y0;
Im_Curseur->Width = LARGEUR;
Im_Curseur->Height = HAUTEUR;

//Evts  reset automatique
for(int i=0;i<NB_EVENTS-NB_THREADS;i++)
Event[i] = CreateEvent(NULL,FALSE,FALSE,NULL);

//evts  reset manuel
Event[STOP_LEC]= CreateEvent(NULL,TRUE,FALSE,NULL);
Event[STOP_ECR]= CreateEvent(NULL,TRUE,FALSE,NULL);
Event[STOP_AFF]= CreateEvent(NULL,TRUE,FALSE,NULL);
Event[STOP_SYN]= CreateEvent(NULL,TRUE,FALSE,NULL);

//Evnts pr le port serie
ovlpe.hEvent = CreateEvent(NULL,FALSE,FALSE,NULL);
ovlpl.hEvent = CreateEvent(NULL,FALSE,FALSE,NULL);

//Eske on lit les vals ou pause ?
lit_vals = false;

//Creation des threads
hThread_L = CreateThread(NULL,0,Thread_Lect,NULL,0,&threadID_L);
hThread_E = CreateThread(NULL,0,Thread_Ecr,NULL,0,&threadID_E);
hThread_S = CreateThread(NULL,0,Thread_Sync,NULL,0,&threadID_sync);
hThread_A = CreateThread(NULL,0,Thread_Affich,NULL,0,&threadID_aff);

//Mutex pour les buffers
mutex_lec = CreateMutex(NULL,FALSE,NULL);
mutex_aff = CreateMutex(NULL,FALSE,NULL);

//Verifie si threads correctement crs
if(hThread_L==INVALID_HANDLE_VALUE) Beep();
if(hThread_E==INVALID_HANDLE_VALUE) Beep();
if(hThread_S==INVALID_HANDLE_VALUE) Beep();


//Plus zoli :)
Ombre3D->Top=Y0-1;
Ombre3D->Left=X0;
Ombre3D->Width=500+2;
Ombre3D->Height=HAUTEUR+2;

//Bienvenue
StatusBar->SimpleText = " Zdravstvouyte :)";

//On commence av 1s/div
TmpDiv->ItemIndex = 12;
tmp_div = 12;

//Remplissage de la structure des calibres de tmp et de V
ModeTmp[0].mode = MODE_TMP_3;
ModeTmp[0].val_mode = INFINI;
ModeTmp[1].mode = MODE_TMP_5;
ModeTmp[1].val_mode = INFINI;
for(int i = 2;i<9;i++) ModeTmp[i].mode = MODE_TMP_VAR;
for(int i = 9;i<17;i++) ModeTmp[i].mode = MODE_TMP_LENT;
ModeTmp[2].val_mode = 1;
ModeTmp[3].val_mode = 3;
ModeTmp[4].val_mode = 9;
ModeTmp[5].val_mode = 19;
ModeTmp[6].val_mode = 39;
ModeTmp[7].val_mode = 99;
ModeTmp[8].val_mode = 199;
ModeTmp[9].val_mode = 1;
ModeTmp[10].val_mode = 4;
ModeTmp[11].val_mode = 9;
ModeTmp[12].val_mode = 19;
ModeTmp[13].val_mode = 49;
ModeTmp[14].val_mode = 99;
ModeTmp[15].val_mode = 149;
ModeTmp[16].val_mode = 199;
for(int i = 0;i<9;i++) ModeTmp[i].nb_a_lire = N;
for(int i = 9;i<17;i++) ModeTmp[i].nb_a_lire = NB_A_LIRE_LIVE;


ModeTmp[0].div = 0.15E-5;
ModeTmp[1].div = 0.25E-5;
ModeTmp[2].div = 0.5E-5;
ModeTmp[3].div = 1.0E-5;
ModeTmp[4].div = 2.5E-5;
ModeTmp[5].div = 5E-5;
ModeTmp[6].div = 10E-5;
ModeTmp[7].div = 25E-5;
ModeTmp[8].div = 50E-5;
ModeTmp[9].div = 100E-5;
ModeTmp[10].div = 250E-5;
ModeTmp[11].div = 500E-5;
ModeTmp[12].div = 1000E-5;
ModeTmp[13].div = 2500E-5;
ModeTmp[14].div = 5000E-5;
ModeTmp[15].div = 7500E-5;
ModeTmp[16].div = 10000E-5;


//Idem pr les volts
ModeV[0].mode = 'c';
ModeV[1].mode = 'B';
ModeV[2].mode = 'a';
ModeV[3].mode = 'D';
ModeV[4].mode = 'g';
ModeV[5].mode = 'H';

ModeV[0].div = 0.1562;
ModeV[1].div = 0.0781;
ModeV[2].div = 0.039;
ModeV[3].div = 0.0195;
ModeV[4].div = 0.0097;
ModeV[5].div = 0.0049;

//Par defaut le plus grand calibre
VDiv->ItemIndex = 0;

//crayons pr dessiner
crayon_gris = CreatePen(PS_SOLID,0,RGB(230,230,230));
crayon_cur1 = CreatePen(PS_SOLID,0,RGB(64,255,251));
crayon_cur2 = CreatePen(PS_SOLID,0,RGB(255,170,70));
crayon_bleu = CreatePen(PS_SOLID,0,RGB(0,128,255));
crayon_trig = CreatePen(PS_DASHDOTDOT,0,RGB(70,250,70));

TmpDiv->Enabled = false;
VDiv->Enabled = false;
trigger_on = false;

}

//---------------------------------------------------------------------------
// Init la carte & commence la lecture
//---------------------------------------------------------------------------


void __fastcall TFenetre::Ouvre_ComClick(TObject *Sender)
{
SetEvent(Event[INIT_CARTE]);
}


//---------------------------------------------------------------------------
// Ferme tout proprement
//---------------------------------------------------------------------------

void __fastcall TFenetre::FrezBtnClick(TObject *Sender)
{
if(carte_ok) {
if(!lit_vals) {
FrezBtn->Caption="Freeze ! :)";
lit_vals = true;
SetEvent(Event[AFFICH_VALS]); }
else
{
FrezBtn->Caption="Oscille :)";
lit_vals = false; }
}
}

//---------------------------------------------------------------------------
// Change les calibres de tmp
//---------------------------------------------------------------------------
void __fastcall TFenetre::TmpDivChange(TObject *Sender)
{
        lit_vals=false;
        SetEvent(Event[CHANGE_CAL]);
}

//---------------------------------------------------------------------------
// Idem pr les volts
//---------------------------------------------------------------------------
void __fastcall TFenetre::VDivChange(TObject *Sender)
{
        lit_vals=false;
        SetEvent(Event[CHANGE_CAL]);
}
//---------------------------------------------------------------------------
// Change FFT / Courbe
//---------------------------------------------------------------------------

void __fastcall TFenetre::ButtonClick(TObject *Sender)
{

        SetEvent(Event[AFFICH_OK]);
        // Affichage de la courbe
        if(Bool_FFT == true)
                { Bool_FFT=false;
                Button->Caption = "FFT";
                ButtonTrig->Enabled = true;
                Edit_periode->Text = (Periode(val, N, 1))*2*ModeTmp[tmp_div].div;
                MinMax(max, min);
                EditMin->Text = min;
                EditMax->Text = max; }
        // Affichage de la FFT
        else
                {Bool_FFT = true;
                Button->Caption = "Courbe";
                ButtonTrig->Enabled = false;
                Edit_periode->Text = "";
                EditMin->Text = "";
                EditMax->Text = "";
                }
        // Desactivation des curseurs
        click1_save = false;
        click2_save = false;
}
//---------------------------------------------------------------------------

void __fastcall TFenetre::ScrollBar_TriggerChange(TObject *Sender)
{
        SetEvent(Event[AFFICH_OK]);
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------

void __fastcall TFenetre::Button_NocurseurClick(TObject *Sender)
{
        Bool_Nocurseur = true;
        Bool_Curseur1 = false;
        Bool_Curseur2 = false;

        Button_Nocurseur->Caption = "<No Curseur>";
        Button_Curseur1->Caption = "Curseur 1";
        Button_Curseur2->Caption = "Curseur 2";

        SetEvent(Event[AFFICH_OK]);
        click1_save = false;
        click2_save = false;
        DeltaX->Text = "";
        DeltaY->Text = "";
}
//---------------------------------------------------------------------------

void __fastcall TFenetre::Button_Curseur1Click(TObject *Sender)
{
        Bool_Nocurseur = false;
        Bool_Curseur1 = true;
        Bool_Curseur2 = false;

        Button_Nocurseur->Caption = "No Curseur";
        Button_Curseur1->Caption = "<Curseur 1>";
        Button_Curseur2->Caption = "Curseur 2";
}
//---------------------------------------------------------------------------

void __fastcall TFenetre::Button_Curseur2Click(TObject *Sender)
{
        Bool_Nocurseur = false;
        Bool_Curseur1 = false;
        Bool_Curseur2 = true;

        Button_Nocurseur->Caption = "No Curseur";
        Button_Curseur1->Caption = "Curseur 1";
        Button_Curseur2->Caption = "<Curseur 2>";
}
//---------------------------------------------------------------------------

void __fastcall TFenetre::Button1Click(TObject *Sender)
{
       
//Libre les mutex
ReleaseMutex(mutex_aff);
ReleaseMutex(mutex_lec);

//Arrete les threads Affich & Synchro
SetEvent(Event[STOP_AFF]);
SetEvent(Event[STOP_SYN]);

SetEvent(Event[AFFICH_OK]);

Sleep(200);
//Arrete de lire les valeurs
lit_vals = false;

//on attend que les threads se terminent
bool finie=false,finil=false,finis=false,finia=false;

//evenement recu (cf plus loin)
DWORD event;

//les evenements  attendre
HANDLE hEvents[] = {Event[TH_LEC_FINI],Event[TH_ECR_FINI],Event[TH_SYN_FINI],Event[TH_AFF_FINI]};

//Tant que tous les threads sont pas finis
while(!(finie && finil && finis && finia))
{
        //attend de recevoir un evenement de hEvents
        event = WaitForMultipleObjects(4,hEvents,FALSE,INFINITE);
        switch(event) {
        case WAIT_OBJECT_0 : finil=true; break;
        case WAIT_OBJECT_0 + 1 : finie=true; break;
        case WAIT_OBJECT_0 + 2 : finis=true; break;
        case WAIT_OBJECT_0 + 3 : finia=true; break;
        }
}   

//Ferme proprement les handles des threads
if(hThread_L != INVALID_HANDLE_VALUE) CloseHandle(hThread_L);
if(hThread_E != INVALID_HANDLE_VALUE) CloseHandle(hThread_E);
if(hThread_S != INVALID_HANDLE_VALUE) CloseHandle(hThread_S);
if(hThread_A != INVALID_HANDLE_VALUE) CloseHandle(hThread_A);

//Mutex's
if(mutex_lec != INVALID_HANDLE_VALUE) CloseHandle(mutex_lec);
if(mutex_aff != INVALID_HANDLE_VALUE) CloseHandle(mutex_aff);

//Ferme proprement les handles des events
for(int i=0;i<NB_EVENTS;i++)
        if(Event[i] != INVALID_HANDLE_VALUE)
        CloseHandle(Event[i]);

//Ferme le port ! peut etre utile pour d'autres prgms...
if(hPortSerie != NULL) CloseHandle(hPortSerie);

//Libre les buffers & les events
delete[] buffer_l;
delete[] buffer_a;
delete[] Event;

Close();
}
//---------------------------------------------------------------------------
// Active ou desactive le trigger
//---------------------------------------------------------------------------


void __fastcall TFenetre::ButtonTrigClick(TObject *Sender)
{
if(trigger_on) {
trigger_on = false;
ButtonTrig->Caption = "Activer Trigger";
SetEvent(Event[TRIG_OFF]);
lit_vals = true;
SetEvent(Event[AFFICH_VALS]);}
else {
trigger_on = true;
ButtonTrig->Caption = "Desactiver Trigger";
lit_vals = false;
SetEvent(Event[TRIG_ON]);
}
}
//---------------------------------------------------------------------------







