//---------------------------------------------------------------------------

#ifndef OscH
#define OscH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <ComCtrls.hpp>

#define X0 43        //x origine du graf
#define Y0 20       //y origine du graph
#define N 1024       //nb de points
#define HAUTEUR 256   //nb de pixels en hauteur
#define LARGEUR 500

#define KO false
#define OK true
#define STOPPED  123
#define ECHEC    22
#define NOTDONE  33
#define DONE     44

#define Fori(a) for (int i = 0 ; i < a ; i++ )
#define Forj(a) for (int j = 0 ; j < a ; j++ )
#define Fork(a) for (int k = 0 ; k < a ; k++ )

#define TEMPS_MIN 'm'

#define LEC_OK  0
#define ECR_OK  1
#define LEC_PB  2
#define ECR_PB  3

#define INFINI  -1
#define NB_A_LIRE_LIVE 1
#define NB_MODE_TMP 17
#define NB_MODE_V 6

//Evenements
#define TH_LEC_FINI     0
#define TH_ECR_FINI     1
#define TH_SYN_FINI     2
#define DEB_ECR         3
#define DEB_LEC         4
#define SYN_FIN         5
#define LEC_FIN         6
#define ECR_FIN         7
#define INIT_CARTE      8
#define TH_AFF_FINI     9
#define AFFICH_OK       10
#define AFFICH_VALS     11
#define STOP_VALS       12
#define CHANGE_CAL      13
#define LEC_ATTENTE     14
#define TRIG_ON         15
#define TRIG_OFF        16
#define STOP_ECR        17
#define STOP_LEC        18
#define STOP_SYN        19
#define STOP_AFF        20
#define NB_EVENTS       21
#define NB_THREADS      4


//Octets PIC
#define MODE_TMP_3      'm'
#define MODE_TMP_5      'f'
#define MODE_TMP_VAR    'v'
#define MODE_TMP_LENT   'l'
#define BYTE_STOP_LIVE  'n'
#define TRIGGER         't'
#define STOP_TRIG       'n'

typedef struct { char mode; int val_mode; int nb_a_lire; double div;} struct_mode;
//---------------------------------------------------------------------------
class TFenetre : public TForm
{
__published:	// Composants grs par l'EDI
        TButton *Ouvre_Com;
        TStatusBar *StatusBar;
        TComboBox *PortComChoix;
        TBevel *Ombre3D;
        TLabel *LabelTrig;
        TLabel *LabelTime;
        TLabel *LabelValue;
        TImage *Im_Curseur;
        TGroupBox *GroupBox1;
        TGroupBox *GroupBox2;
        TGroupBox *GroupBox3;
        TLabel *Label9;
        TLabel *Label4;
        TLabel *Label3;
        TEdit *Edit_periode;
        TEdit *EditMin;
        TEdit *EditMax;
        TLabel *LabelDX;
        TLabel *LabelDY;
        TEdit *DeltaX;
        TEdit *DeltaY;
        TButton *Button;
        TScrollBar *ScrollBar_Trigger;
        TScrollBar *ScrollBar_Sensible;
        TEdit *Edit1;
        TEdit *Edit2;
        TButton *Button_Nocurseur;
        TButton *Button_Curseur1;
        TButton *Button_Curseur2;
        TGroupBox *GroupBox4;
        TGroupBox *GroupBox5;
        TComboBox *VDiv;
        TComboBox *TmpDiv;
        TButton *FrezBtn;
        TButton *Button1;
        TButton *ButtonTrig;
        TLabel *LabelY0;
        TLabel *LabelYM1;
        TLabel *LabelY1;
        void __fastcall Ouvre_ComClick(TObject *Sender);
        void __fastcall FrezBtnClick(TObject *Sender);
        void __fastcall TmpDivChange(TObject *Sender);
        void __fastcall VDivChange(TObject *Sender);
        void __fastcall Im_CurseurClick(TObject *Sender);
        void __fastcall Im_CurseurMouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
        void __fastcall ButtonClick(TObject *Sender);
        void __fastcall ScrollBar_TriggerChange(TObject *Sender);
        void __fastcall Button_NocurseurClick(TObject *Sender);
        void __fastcall Button_Curseur1Click(TObject *Sender);
        void __fastcall Button_Curseur2Click(TObject *Sender);
        void __fastcall Button1Click(TObject *Sender);
        void __fastcall ButtonTrigClick(TObject *Sender);

private:
        //Identifiant des threads
        DWORD threadID_L,threadID_E,threadID_sync,threadID_aff;

        //Handle des threads, des pointeurs en gros
        HANDLE hThread_L,hThread_E,hThread_S,hThread_A;

        //fonction des threads
        static __stdcall DWORD  Thread_Lect(LPVOID lpParam);
        static __stdcall DWORD  Thread_Ecr(LPVOID lpParam);
        static __stdcall DWORD  Thread_Sync(LPVOID lpParam);
        static __stdcall DWORD  Thread_Affich(LPVOID lpParam);

public:
        int nb_a_lire;
        //pour dessiner comme un Warrior
        HDC dc;

        //Evenements
        HANDLE * Event;

        //Port serie
        HANDLE hPortSerie;

        //evenement fin lect & ecr
        OVERLAPPED ovlpl,ovlpe;

        //Port COM
        char com_port[4];
        DCB dcb;

        CRITICAL_SECTION GlobalCriticalSection; 
        //buffer lec & ecriture & affichage + mutex
        char buffer_e;
        unsigned char* buffer_l,*buffer_a;
        HANDLE mutex_lec,mutex_aff;     //pour les changements de buffers

        bool    lit_vals;       //eske on lit des valeurs ou pas ?
        int     tmp_div;        //index de la structure
        int     v_div;
        bool    carte_ok;       //ou est la carte

        //les temps/div
        struct_mode ModeTmp[NB_MODE_TMP];
        struct_mode ModeV[NB_MODE_V];

        //resultats lec & ecr
        int res_lec;
        int res_ecr;

        //fonctions pr le port serie
        DWORD Lec_TimeOut;
        bool Ecrit_Serie(void);
        bool Lit_Serie(void);
        bool Lit_Vals(int ind);
        bool Trig_Vals();
        char Commande(char buffer);
        bool Ecrit(unsigned char buffer);

        //fonction de synchro
        bool InitCarte(void);
        bool Lecture(void);
        void Change_Cals(void);
        bool TriggerOn();
        void ErreurreuIO();

        HPEN crayon_gris,crayon_cur1,crayon_cur2,crayon_bleu,crayon_trig;

        //Fonctions grafiques
        double * val;
        bool Bool_FFT;
        void __fastcall DessineGraph(int debut);
        void __fastcall DessineFFT();
        void __fastcall Dessine();

        int Xtemp, Ytemp, X1, X2, Y1, Y2;
        bool click1_save, click2_save;
        double * fft_tablo;

        bool Bool_Nocurseur, Bool_Curseur1, Bool_Curseur2;
        bool trigger_on;

        double max, min;
        int Periode(double* val, int taille, int k);
        void MinMax(double &max, double &min);

        void FFTiter(double * signal ,const int n , double* fft);

        int Trigger(int Sensibilite_Trig);

        void AfficheCurseur();

        void CharToDouble(unsigned char * signal, double * val);

        __fastcall TFenetre(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TFenetre *Fenetre;
//---------------------------------------------------------------------------
#endif
